from pandac.PandaModules import *
from direct.task import Task

from simulation.weapon import *
from random import random as r
from random import *

class Stoner:
    
    def __init__(self,game):
        pass
        
    def takeShip(self,ship):
        self.ship = ship
        ship.pilot = self
    
    def think(self,dt):
        pass


class Flyer:
    
    def __init__(self,game):
        pass
        
    def takeShip(self,ship):
        self.ship = ship
        ship.pilot = self
    
    def think(self,dt):
        self.ship.node.setHpr(self.ship.node.getHpr() + Vec3(r()*2-1,r()*2-1,r()*2-1) )
        self.ship.speed = 45
        
        if (self.ship.node.getPos()).length() > 10000:
            self.ship.node.lookAt(Point3(0,0,0))




class Killer:
    
    def __init__(self,game):
        self.torget = None
        self.fired = 0
        
    def takeShip(self,ship):
        self.ship = ship
        ship.pilot = self
    
    def think(self,dt):
        
        if self.torget == None:
            self.torget = choice(self.ship.world.ships.values())
        try:
            hpr = self.ship.node.getHpr()
            self.ship.node.lookAt(self.torget.node)
            hprLookAt = self.ship.node.getHpr()
            self.ship.node.setHpr(hpr*.9+hprLookAt*.1)
        except AssertionError:
            self.torget = None
            
        if self.torget != None:
            #self.ship.node.setHpr(self.ship.node.getHpr() + Vec3(r()*2-1,r()*2-1,r()*2-1) )
            self.ship.speed = 36
            
            if (self.torget.node.getPos()-self.ship.node.getPos()).length() < 500 :
                self.fired += dt
                if self.fired > 1:
                    self.fired = 0
                    self.ship.world.fire(self.ship,Projectile())
                    
          
    
        